TauP_Pierce (TauP 2.6.1 API)
Description: declaration: package: edu.sc.seis.TauP, class: TauP_Pierce

Package edu.sc.seis.TauP

# Class TauP_Pierce

java.lang.Object
edu.sc.seis.TauP.TauP_Tool
edu.sc.seis.TauP.TauP_Time
edu.sc.seis.TauP.TauP_Pierce

Direct Known Subclasses:
  `TauP_Path`

    public class TauP_Pierce
    extends TauP_Time

Calculate pierce points for different branches using linear interpolation between known slowness samples. A pierce point is where a ray pierces a tau branch. This gives a (very) rough path through the model for a ray.

- ## Field Summary

  Fields
  Modifier and Type | Field | Description
  --- | --- | ---
  `protected double[]` | `addDepth` |
  `protected boolean` | `onlyAddPoints` |
  `protected boolean` | `onlyRevPoints` |
  `protected boolean` | `onlyTurnPoints` |
  `protected boolean` | `onlyUnderPoints` |

  ### Fields inherited from class edu.sc.seis.TauP.TauP_Time

  `arrivals, azimuth, backAzimuth, degrees, depth, distKilometers, eventLat, eventLon, GUI, modelName, onlyPrintRayP, onlyPrintTime, phaseNames, receiverDepth, relativeArrival, relativePhaseName, stationLat, stationLon, takeoffAngle, tMod, tModDepth`

  ### Fields inherited from class edu.sc.seis.TauP.TauP_Tool

  `DEBUG, expert, GMT, JSON, outFileBase, outForms, outputFormat, SVG, TEXT, toolProps, verbose, writer`

- ## Constructor Summary

  Constructors
  Modifier | Constructor | Description
  --- | --- | ---
  `protected` | `TauP_Pierce()` |
  `` | `TauP_Pierce​(TauModel tMod)` |
  `` | `TauP_Pierce​(java.lang.String modelName)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `appendAddDepths​(java.lang.String depthString)` |
  `void` | `calculate​(double degrees)` |
  `void` | `depthCorrect​(double depth, double receiverDepth)` | override depthCorrect so that we can put the pierce depths in.
  `boolean` | `isAddDepth​(double depth)` | checks to see if the given depth has been "added" as a pierce point.
  `static void` | `main​(java.lang.String[] args)` | Allows TauP_Pierce to run as an application.
  `protected double[]` | `parseAddDepthsList​(java.lang.String depthList)` |
  `java.lang.String[]` | `parseCmdLineArgs​(java.lang.String[] args)` |
  `void` | `printResult​(java.io.PrintWriter out)` |
  `void` | `printUsage()` | prints the known command line flags.
  `void` | `setAddDepths​(java.lang.String depthString)` | sets depths for additional pierce points, ie depths that are not really discontinuities in the model.
  `void` | `setOnlyAddPoints​(boolean onlyAddPoints)` |
  `void` | `setOnlyRevPoints​(boolean onlyRevPoints)` |
  `void` | `setOnlyTurnPoints​(boolean onlyTurnPoints)` |
  `void` | `setOnlyUnderPoints​(boolean onlyUnderPoints)` |

  ### Methods inherited from class edu.sc.seis.TauP.TauP_Time

  `appendPhaseName, appendPhaseName, calcTakeoff, calcTime, clearArrivals, clearPhaseNames, clearPhases, depthCorrect, destroy, getArrival, getArrivals, getDisconDepths, getNumArrivals, getNumPhases, getPhaseNames, getPhaseNames, getPhaseNameString, getReceiverDepth, getSeismicPhases, getSourceDepth, getTauModel, getTauModelDepthCorrected, getTauModelName, init, linearInterp, loadTauModel, parseDegreeList, parsePhaseList, printHelp, printResultJSON, printResultText, printStdUsage, printStdUsageHead, readPhaseFile, readTauModel, recalcPhases, setPhaseNames, setPhaseNames, setReceiverDepth, setSourceDepth, setTauModel, sortArrivals, start`

  ### Methods inherited from class edu.sc.seis.TauP.TauP_Tool

  `dashEquals, endGmtAndCleanUp, getOutFile, getOutFileBase, getOutFileExtension, getOutputFormat, getWriter, parseCommonCmdLineArgs, printNoComprendoArgs, printScriptBeginning, printStdUsageHead, printStdUsageTail, setOutFileBase, setOutFileExtension, setOutputFormat, setWriter, toolNameFromClass`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### onlyTurnPoints

    protected boolean onlyTurnPoints

  - ### onlyRevPoints

    protected boolean onlyRevPoints

  - ### onlyUnderPoints

    protected boolean onlyUnderPoints

  - ### onlyAddPoints

    protected boolean onlyAddPoints

  - ### addDepth

    protected double[] addDepth

- ## Constructor Details

  - ### TauP_Pierce

    protected TauP_Pierce()

  - ### TauP_Pierce

    public TauP_Pierce​(TauModel tMod) throws TauModelException
    Throws:
      `TauModelException`

  - ### TauP_Pierce

    public TauP_Pierce​(java.lang.String modelName) throws TauModelException
    Throws:
      `TauModelException`

- ## Method Details

  - ### setOnlyTurnPoints

    public void setOnlyTurnPoints​(boolean onlyTurnPoints)

  - ### setOnlyRevPoints

    public void setOnlyRevPoints​(boolean onlyRevPoints)

  - ### setOnlyUnderPoints

    public void setOnlyUnderPoints​(boolean onlyUnderPoints)

  - ### setOnlyAddPoints

    public void setOnlyAddPoints​(boolean onlyAddPoints)

  - ### setAddDepths

    public void setAddDepths​(java.lang.String depthString)
    sets depths for additional pierce points, ie depths that are not really discontinuities in the model.

  - ### appendAddDepths

    public void appendAddDepths​(java.lang.String depthString)

  - ### parseAddDepthsList

    protected double[] parseAddDepthsList​(java.lang.String depthList)

  - ### depthCorrect

    public void depthCorrect​(double depth, double receiverDepth) throws TauModelException
    override depthCorrect so that we can put the pierce depths in.
    Overrides:
      `depthCorrect` in class `TauP_Time`
    Parameters:
      `depth` - the source depth
      `receiverDepth` - the receiver depth
    Throws:
      `TauModelException`

  - ### calculate

    public void calculate​(double degrees) throws TauModelException
    Overrides:
      `calculate` in class `TauP_Time`
    Throws:
      `TauModelException`

  - ### printResult

    public void printResult​(java.io.PrintWriter out) throws java.io.IOException
    Overrides:
      `printResult` in class `TauP_Time`
    Throws:
      `java.io.IOException`

  - ### isAddDepth

    public boolean isAddDepth​(double depth)
    checks to see if the given depth has been "added" as a pierce point.

  - ### printUsage

    public void printUsage()
    prints the known command line flags.
    Overrides:
      `printUsage` in class `TauP_Time`

  - ### parseCmdLineArgs

    public java.lang.String[] parseCmdLineArgs​(java.lang.String[] args) throws java.io.IOException
    Overrides:
      `parseCmdLineArgs` in class `TauP_Time`
    Throws:
      `java.io.IOException`

  - ### main

    public static void main​(java.lang.String[] args) throws java.io.IOException
    Allows TauP_Pierce to run as an application. Creates an instance of TauP_Pierce. ToolRun.main should be used instead.
    Throws:
      `java.io.IOException`